// Generated by CoffeeScript 1.4.0
(function() {
  var $, xo,
    __slice = [].slice,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  xo = {
    _handlers: {},
    handlers: function(name) {
      var _base;
      return (_base = xo._handlers)[name] || (_base[name] = []);
    },
    on: function(name, handler) {
      return !xo.handlers(name).push(handler);
    },
    emit: function() {
      var args, handler, name;
      name = arguments[0], args = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
      return ((function() {
        var _i, _len, _ref, _results;
        _ref = xo.handlers(name);
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          handler = _ref[_i];
          _results.push(handler.apply(null, args));
        }
        return _results;
      })()).length > 0;
    },
    removeListener: function(name, handler) {
      var t, _ref;
      if ((t = xo.handlers(name).indexOf(handler)) > -1) {
        return ([].splice.apply(xo.handlers(name), [t, t - t + 1].concat(_ref = [])), _ref);
      }
    }
  };

  if ((typeof module !== "undefined" && module !== null ? module.exports : void 0) != null) {
    module.exports = xo;
    $ = require('jquery');
  } else {
    window.xo = xo;
    $ = window.$;
  }

  xo.Agent = (function() {

    function Agent(config) {
      var handler, key, name, val, _ref;
      for (key in config) {
        val = config[key];
        this[key] = val;
      }
      this.__handlers = {};
      _ref = this.on;
      for (name in _ref) {
        handler = _ref[name];
        this.__handlers[name] = handler.bind(this);
        xo.on(name, this.__handlers[name]);
      }
    }

    Agent.prototype.destroy = function() {
      var handler, name, _ref, _results;
      _ref = this.__handlers;
      _results = [];
      for (name in _ref) {
        handler = _ref[name];
        _results.push(xo.removeListener(name, handler));
      }
      return _results;
    };

    return Agent;

  })();

  xo.View = (function(_super) {

    __extends(View, _super);

    function View(config) {
      var handler, name, _ref;
      this.children = [];
      View.__super__.constructor.call(this, config);
      if (typeof this.$ === "string") {
        this.el = $(this.$);
      } else if (typeof this.$ === "function") {
        this.el = $(this.$.call(this));
      }
      _ref = this.bind;
      for (name in _ref) {
        handler = _ref[name];
        this.el.bind(name, handler.bind(this));
      }
    }

    View.prototype.append = function(selector, child) {
      var el;
      if (child != null) {
        el = this.el.find(selector);
      } else {
        el = this.el;
        child = selector;
      }
      this.children.push(child);
      return el.append(child.el);
    };

    View.prototype.destroy = function() {
      var child, _i, _len, _ref;
      _ref = this.children;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        child = _ref[_i];
        child.destroy();
      }
      return View.__super__.destroy.call(this);
    };

    return View;

  })(xo.Agent);

}).call(this);
